package ip_database;

use POE;
use plugin;
use DBI;
use modules;
use Net::FTP;

sub CHANNEL () { plugin::get_irc_channel()  };

our %additional_events =
(
  # other functions
  "SavePlayerInfo" => "SavePlayerInfo",
  "updatelist" => "updatelist",
  "ftpupload" => "ftpupload",

  # !command functions
  "ipsearch" => "ipsearch",
  "nicksearch" => "nicksearch",
  "totals" => "totals"
);

our $plugin_name;
our %config;
our $dbh;
our $dbVersion;
our $currentVersion = 1.3;

my $pluginVersion = 1.3;

sub start
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};

	$next_time = int( time() ) + 5;
	$kernel->alarm( updatelist => $next_time => \%args );

	plugin::set_global ( "version_plugin_ip_database", $pluginVersion );

	opendir( DIR, '.' );
	my $time = &get_log_time('ipdatabase.dat');

	$dbh = DBI->connect("dbi:SQLite2:dbname=ipdatabase.dat","","");

	if( !$time )
	{
		$dbh->do("create table playerinfo (name int ,ipaddress   int ,date   int)");
		$dbh->do("create table globals ( name char(1024) PRIMARY KEY, value char(1024))");
		set_global ("version", $currentVersion);
	}
	closedir DIR;


}

sub stop
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];

	$dbh->disconnect;
}

sub playerjoin
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};

	my $next_time = int( time() ) + 3;
	$kernel->alarm( SavePlayerInfo => $next_time => $args{nick} );
}


sub SavePlayerInfo
{
	my ( $session, $heap, $player ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my $name = $matched_hash->{name};		$name =~ s/"/\'/;
        my $timestamp = modules::get_date_time("MM/DD/YYYY");

	my ( $result, %player ) = plugin::getPlayerData( $player );
        $nodata = $dbh->selectrow_array ( "SELECT name, ipaddress FROM playerinfo WHERE name = \"$player{'name'}\" AND ipaddress = \"$player{'ip'}\"" );

	if ( $result == 1 && !$nodata)
	{
        $dbh->do ( "INSERT INTO playerinfo (name, ipaddress, date) VALUES (\"$player{'name'}\", \"$player{'ip'}\", \"$timestamp\")" );
  }
}

sub mapload
{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};

	$next_time = int( time() ) + 5;
	$kernel->alarm( updatelist => $next_time => \%args );
}


sub updatelist
{
	if ( ( $config{fileoutput} == 1 ) )
	{
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];

        $query = $dbh->prepare ( "SELECT name, ipaddress, date FROM playerinfo" );

	open ( FILE, ">./$config{'filename'}" );

       $query->execute();
         while ( @row = $query->fetchrow_array )
         {
         print FILE "$row[0]\t $row[1]\t $row[2] \n";
         }
 	close ( FILE);

	if ( ( $config{siteoutput} == 1 ) )
	{

	my $kernel = $_[KERNEL];
	my %args = %{$args};

	$next_time = int( time() ) + 5;
	$kernel->alarm( ftpupload => $next_time => \%args );
 	}
 }
}

sub ipsearch
{
        my ( $kernel, $session, $heap, $args ) = @_[ KERNEL, SESSION, HEAP, ARG0 ];
        my %args = %{$args};
        my $ipdata = $args{arg1};

        if ($args{arg1} =~ m/^(\d{1,3}|\*)\.?(\d{1,3}|\*)?\.?(\d{1,3}|\*)?\.?(\d{1,3}|\*)?$/)
        {

     	my $result = $dbh->prepare ( "SELECT name, ipaddress, date FROM playerinfo where ipaddress like '%$ipdata%' ORDER by name DESC limit 10" );

        $result->execute();

        my @row = $result->fetchrow_array;

        if ( @row )
        {
        while ( @row )
        {
           plugin::ircmsg ( "[$row[2]]  $row[0] -> $row[1]", A);
           @row = $result->fetchrow_array;
          }
        }
        else
        {
          plugin::ircmsg ( "No results found for '$ipdata'", A); }
        }
        else
       {
        plugin::ircmsg ( "Syntax: !ipsearch <ip>", A);
     }
  }


sub nicksearch
{
        my ( $kernel, $session, $heap, $args ) = @_[ KERNEL, SESSION, HEAP, ARG0 ];
        my %args = %{$args};
        my $nickdata = $args{arg1};

        if ( $args{arg} =~ m/^\!\S+\s(.+)$/i )
        {

     	my $result = $dbh->prepare ( "SELECT name, ipaddress, date FROM playerinfo where name like '%$nickdata%' ORDER by name DESC limit 10" );

        $result->execute();

        my @row = $result->fetchrow_array;

        if ( @row )
        {
        while ( @row )
        {
           plugin::ircmsg ( "[$row[2]]  $row[0] -> $row[1]", A);
           @row = $result->fetchrow_array;
          }
        }
        else
        {
          plugin::ircmsg ( "No results found for '$nickdata'", A); }
        }
        else
       {
        plugin::ircmsg ( "Syntax: !nicksearch <nick>", A);
     }
  }


sub totals
{
       my ( $kernel, $session, $heap, $args ) = @_[ KERNEL, SESSION, HEAP, ARG0 ];
       my %args = %{$args};

       my $query = $dbh->prepare ("SELECT COUNT(*) FROM (SELECT ipaddress, count(ipaddress) FROM playerinfo GROUP BY ipaddress);" );

       $query->execute();

       my @row = $query->fetchrow_array;
       my $ips = $row[0];

       $query = $dbh->prepare ("select count(*) from ( SELECT name, count(name) from playerinfo group by name );" );

       $query->execute();

       @row = $query->fetchrow_array;

       my $names = $row[0];

       plugin::ircmsg ( "There are $ips unique ip address and $names unique names in the database.", A);
}


sub ftpupload
{
	my $ftp = Net::FTP->new( "$config{'ftpServer'}", Debug => 0 );
	if ( $ftp )
	{
		if ( $ftp->login( $config{'ftpUsername'},$config{'ftpPassword'} ) )
		{
			print "IP DATABASE :: FTP :: Login Successful\n";
			if ( $ftp->cwd( $config{'ftpPath'} ) )
			{
				# Upload the file
				if ( $ftp->put ( "./$config{'filename'}" ) )
				{
					print "IP DATABASE :: FTP :: File $config{'filename'} uploaded successful\n";
				}
				else
				{
					print "IP DATABASE :: FTP :: File upload failed\n";
				}
			}
			else
			{
				print "IP DATABASE :: FTP :: '$config{ftpPath}' does not found\n";
			}

			$ftp->quit;
			print "IP DATABASE :: FTP :: Disconnected\n";
		}
		else
		{
			print "IP DATABASE :: FTP :: Login Failed\n";
		}
	}
}


sub command
{
	# trigger on !commands
	my ( $session, $heap, $args ) = @_[ SESSION, HEAP, ARG0 ];
	my $kernel = $_[KERNEL];
	my %args = %{$args};

	# each command from IRC/ingame comes here first. have to trigger the approriate functions from here
	if ( $args{command} eq "ipsearch" )
	{
		$kernel->yield("ipsearch" => \%args);
	}
	elsif ( $args{command} eq "nicksearch" )
	{
		$kernel->yield("nicksearch" => \%args);
	}
	elsif ( $args{command} eq "totals" )
	{
		$kernel->yield("totals" => \%args);
	}
}


sub get_log_time {
	my ($logfile) = @_;

	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($logfile);

	return($mtime);
}

sub set_global {
	my ($name, $value) = @_;

	my ($excists) = $dbh->selectrow_array ("SELECT count(*) FROM globals WHERE  name  = '$name'");

	if( $excists == 1 ) {
		$dbh->do ("UPDATE globals SET	value = '$value' WHERE  name  = '$name'");
	}
	else {
		$dbh->do ("INSERT INTO globals VALUES( '$name', '$value')");
	 }
       }

1;